package org.gcube.dataanalysis.executor.rscripts;

import java.io.File;
import java.util.ArrayList;
import java.util.LinkedHashMap;
import org.gcube.dataanalysis.ecoengine.datatypes.PrimitiveType;
import org.gcube.dataanalysis.ecoengine.datatypes.StatisticalType;
import org.gcube.dataanalysis.ecoengine.datatypes.enumtypes.PrimitiveTypes;
import org.gcube.dataanalysis.executor.rscripts.generic.GenericRScript;
import org.gcube.dataanalysis.ecoengine.utils.DynamicEnum;
import java.lang.reflect.Field;

public class RBlackBox extends GenericRScript {

	@Override
	public String getDescription() {
		return "RBlackBox";
	}

	protected void initVariables(){
		mainScriptName="RBlackBox/Main.R";
		packageURL="http://data.d4science.org/U3NrWE1kbGtHMmw4bDRQdDFHSmdFY2lPMFZOVUpXZGFHbWJQNStIS0N6Yz0";
		environmentalvariables = new ArrayList<String>();
		inputvariables.add("text");
		outputvariables.add("file");
	}

	@Override
	protected void setInputParameters() {
		inputs.add(new PrimitiveType(String.class.getName(), null,PrimitiveTypes.STRING, "text", "Input text", "checkinput"));
	}

	@Override
	public StatisticalType getOutput() {
		output.put("file",new PrimitiveType(File.class.getName(), new File(outputValues.get("file")), PrimitiveTypes.FILE, "file", "file"));
		PrimitiveType o = new PrimitiveType(LinkedHashMap.class.getName(), output, PrimitiveTypes.MAP, "Output", "");
		return o;
	}
}
